declare function apply-predicate($context, $condition) {
  typeswitch ($condition) {
    (: numeric predicates filter by position :)
    case $pos as xs:integer return item-at($context, $pos)
    case $pos as xs:float   return item-at($context, $pos)
    case $pos as xs:double  return item-at($context, $pos)
    case $pos as xs:decimal return item-at($context, $pos)

    (: all others are converted to boolean [RG38][MLB39]using EBV
       and then return the expression or the empty sequence :)
    default return if (boolean($condition)) then $context else ()
  }
};